/* global Bdf,$$,ID,SqlExport,CodeMirror,Pane */

SqlExport.Form = {};

SqlExport.Form.load = function (sqlExportName) {
    var sqlExport = SqlExport.getSqlExport(sqlExportName);
    if (!sqlExport) {
        return;
    }
    var isInStock = false;
    var formId = Bdf.generateId();
    $$("layout_main").html(Bdf.render("sqlexport:form", {
        action: Bdf.URL + "exportation",
        formId: formId,
        sqlExportName: sqlExport.name,
        title: sqlExport.title,
        labelArray: Bdf.toLabelArray(sqlExport.labelMap),
        labelsLocKey: "_ title.exportation.sqlexportlabels",
        currentTableExportName : sqlExport.tableExportName,
        tableExportArray: Bdf.Collections.tableExportArray,
        customClassName: sqlExport.sqlExportClassName,
        path: sqlExport.path,
        url: sqlExport.url,
        postCommand: sqlExport.postCommand,
        params: _paramsToString(),
        selectionDefArray: Bdf.Collections.selectionDefArray,
        currentSelectionDefName: sqlExport.selectionDefName,
        queryXml: sqlExport.query.ficheXml + sqlExport.query.motcleXml,
        targetName: sqlExport.targetName,
        targetPath: sqlExport.targetPath,
        fileName: sqlExport.fileName,
        availableTargetArray: Bdf.pathConfiguration.targetArray,
        attributes: Bdf.attrMapToString(sqlExport.attrMap),
        attributesLocKey: "_ title.exportation.sqlexportattributes",
        commandKey: "EXP-43",
        commandUrl: Bdf.getCommandUrl("EXP-43")
    }));
    Bdf.Deploy.init($$("layout_main"));
    $$(formId, "button_stock").click(function () {
        Pane.moveMainToStock();
    });
    $$(formId).ajaxForm({
        beforeSerialize: function ($form, options) {
            if (isInStock) {
                return false;
            } else {
                queryxmlCodeMirror.save();
                attributesCodeMirror.save();
                return true;
            }
        },
        dataType: "json",
        success: function (data, textStatus, jqXHR, $form) {
            Pane.setChange(false);
            _saveCallback(data);
        }
    });
    var queryxmlCodeMirror = Bdf.toCodeMirror(ID(formId, "queryxml"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "xml"
    });
    queryxmlCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    $$(formId, "button_queryparser").click(function () {
        Bdf.Overlay.showFqlEditor(queryxmlCodeMirror.getDoc().getValue(), function (result) {
            queryxmlCodeMirror.getDoc().setValue(result);
        });
    });
    var attributesCodeMirror = Bdf.toCodeMirror(ID(formId, "attributes"), {
        lineWrapping: false,
        lineNumbers: false,
        indentUnit: 4,
        theme: 'bdf',
        mode: "attributes"
    });
    attributesCodeMirror.on("change", function () {
        Pane.setChange(true);
    });
    $$(formId).data("stockHandler", _stockHandler);
    Pane.checkState();
    Pane.checkTooltip($$(formId));
    

    function _saveCallback(data) {
        Bdf.showCommandMessage(data.commandMessage);
        if (data.commandMessage.type === "done") {
            Bdf.updateDefaultValues($$(formId));
            let newSqlExport = SqlExport.updateSqlExport(data.sqlExport);
            Bdf.$($$(formId), {role: "metadata-title"}).html(newSqlExport.title);
        }
    }
    
    function _paramsToString() {
        var params = "";
        for(var i = 0, len =  sqlExport.paramArray.length ; i < len; i++) {
            var param = sqlExport.paramArray[i];
            if (i > 0) {
                params += "\n";
            }
            params += param.name + "=" + param.value;
        }
        return params;
    }
    
    function _stockHandler(stock) {
        isInStock = stock;
        queryxmlCodeMirror.setOption("readOnly", stock);
        attributesCodeMirror.setOption("readOnly", stock);
        Pane.setReadOnly($$(formId), stock);
    }
    
};